// constants
const reminderFox_TOOLTIP_LINE_LENGTH = 100;
const reminderFox_TOOLTIP_WITH_TODOS_LINE_LENGTH = 65;
const reminderFox_STATUS_TEXT_MAX_LENGTH = 40;
const reminderFox_ALERT_TEXT_MAX_LENGTH = 100;
const reminderFox_MONTHLY_WILDCARD = "*";

const reminderFox_HOUR_TIMEOUT = 3600000;;
const reminderFox_SNOOZE_CONST="-SNOOZE";

var reminderFox_alarmList = new Array();



// Cache the last reminders
var reminderFox_lastDay = null;

// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAddRemindersDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
		window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
			"addreminder-dialog", "chrome,centerscreen,resizable", "reminders");
	}
}


function reminderFox_openOptionsDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxOptions");
  
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
		window.openDialog('chrome://reminderFox/content/options.xul', 'reminderFox-options', 'chrome');
	}
}


// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAddTodosDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
	window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul", 
		"addreminder-dialog", "chrome,centerscreen,resizable", "todos");
	}
}

function reminderFox_openDoubleClickDialog(event) {
    if (event.button == 0) {
		var defaultEditType = REMINDER_FOX_DEFAULT_EDIT_DEFAULT;			
		try {
			defaultEditType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
		} catch(e) {
		}	
		
		if ( defaultEditType == "todos" )  {
			reminderFox_openAddTodosDialog();
		}
		else {
			reminderFox_openAddRemindersDialog();
		}
	}

}



function  reminderFox_processAlarm( recentReminder ) {
	var newDate = new Date( recentReminder.date.getFullYear(), recentReminder.date.getMonth(), recentReminder.date.getDate(), 
		recentReminder.date.getHours(), recentReminder.date.getMinutes() );
	if ( recentReminder.allDayEvent ) {
		newDate.setHours( 0, 0 );
	}
	var mins = 	newDate.getMinutes();
	newDate.setMinutes( mins - recentReminder.alarm );
	var alarmTime = newDate.getTime();
	var currentTime = new Date().getTime();

	var timeDifference = alarmTime - currentTime;
	if ( timeDifference < 0 && timeDifference >= -60000 ) {
		timeDifference = 0;
	}
	// check if the time difference occurs in the next 60 minutes
	var timeDifferenceInMinutes = 0;
	if ( timeDifference != 0 ) {
		timeDifferenceInMinutes = timeDifference/60000;
	}

	if ( timeDifferenceInMinutes >= 0 && timeDifferenceInMinutes  <= 60 ) {		
		var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
		var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
		var windowEnumerator =  reminderFox_getWindowEnumerator();
		if (windowEnumerator.hasMoreElements()) {
			var oldestWindow = windowEnumerator.getNext();
			var reminderString = "";
			var timeString = reminderFox_getTimeString(recentReminder);
			if ( timeString == null ) {
				timeString =  reminderFox_getBundle().getString("rf.add.time.allday");
			}

			recentReminder  = reminderFox_processReminderDescription(recentReminder, new Date().getFullYear());	
			reminderString =  recentReminder.summary;
			var monthAsText = reminderFox_getMonthAsText(recentReminder.date.getMonth());	
			var dateString = monthAsText + " " + recentReminder.date.getDate();	 
						
			// check alarm list
			var alarmId = recentReminder.id;

			// if good - add to alarm list
			var found = false;
			for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length && !found; i++ ) {
				var currentAlarmId =  oldestWindow.reminderFox_alarmList[i];
				if ( currentAlarmId.indexOf( alarmId ) == 0 ) {
					if ( currentAlarmId.indexOf( reminderFox_SNOOZE_CONST ) == currentAlarmId.length -reminderFox_SNOOZE_CONST.length ) {
						// if it's been SNOOZED; then ignore as that snooze is going to go off no matter what
						found = true;
						break;;
					}								
				
					// found him
					var index = currentAlarmId.lastIndexOf( ":" );
					var currentAlarmTime = currentAlarmId.substring( index + 1 );
					var alarmTimeDiff = alarmTime - currentAlarmTime;
					if ( alarmTimeDiff < -60000 || alarmTimeDiff >  60000 ) {
						// times are different; delete old and add new
						reminderFox_removeElement( oldestWindow.reminderFox_alarmList, i);
						break;
					}
					else {
						// times are close enough (within a minute); we don't need to add to the list
						found = true;
					}
				}
			}
			if ( !found ) {
				// add him
				 oldestWindow.reminderFox_alarmList.length = oldestWindow.reminderFox_alarmList.length + 1;
				 oldestWindow.reminderFox_alarmList[oldestWindow.reminderFox_alarmList.length - 1]  = alarmId + ":"  + alarmTime;
				var important = "false";
				if ( recentReminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
					important = "true";
				}	
				oldestWindow.setTimeout('reminderFox_showAlarm("'+dateString+'","'+timeString +'","'+alarmId +'","'+alarmTime+ '","'+reminderString + '","'+important+'")', timeDifference);
			}
		}
	}
}



function reminderFox_showAlarm(dateString, timeString, alarmId, alarmTime, reminderString, important) {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator =  reminderFox_getWindowEnumerator();
	
	if (windowEnumerator.hasMoreElements()) {			
		var oldestWindow = windowEnumerator.getNext();
		for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length; i++ ) {
			var currentAlarmId =  oldestWindow.reminderFox_alarmList[i];
			var snooze = false;
			if ( currentAlarmId.indexOf( alarmId ) == 0 ) {
				if ( currentAlarmId.indexOf( reminderFox_SNOOZE_CONST ) == currentAlarmId.length -reminderFox_SNOOZE_CONST.length ) {
					currentAlarmId = currentAlarmId.substring(0, currentAlarmId.length - reminderFox_SNOOZE_CONST.length );
					snooze = true;
				}
				var index = currentAlarmId.lastIndexOf( ":" );
				var currentAlarmTime;
				if ( snooze ) {
						currentAlarmTime = parseInt( alarmTime );
				} 
				else {
					currentAlarmTime = currentAlarmId.substring( index + 1 );					
				}
				
				var alarmTimeDiff = alarmTime - currentAlarmTime;

				// ensure that the current stored alarm time is the same as the alarm time this function was called with.  
				// This check is in case the user changed the alarm time after the first timeout had been issued.  You only 
				// want to show one alert at the last time the user selected
				if ( alarmTimeDiff >= -60000 && alarmTimeDiff <=  60000 ) {			
					if ( !snooze ) {									
						// secondary check - in case of FireFox setTimeout Bug;		
						// check if the current time is about  when the alarm was set for
						var currentSystemTime = new Date().getTime();		
						var alarmSystemTimeDiff = alarmTime - currentSystemTime;	
						if ( alarmSystemTimeDiff < -60000 || alarmSystemTimeDiff >  60000 ) {		
							return;
						}						
					}				
					// found him
					reminderFox_removeElement( oldestWindow.reminderFox_alarmList, i);
					// otherwise, ignore - dont' show dialog
					var newOptions = {   reminderDate: dateString, reminderTime: timeString, currentAlarmId: alarmId, reminderText: reminderString, importantStatus: important};
					window.openDialog("chrome://reminderfox/content/alarmDialog.xul",
							"alarmOptionsDialog" + alarmId, "chrome,resizable", newOptions);
					break;		
				}
			}
		}
	}
}


// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAboutReminderFoxDialog() {
	window.openDialog("chrome://reminderfox/content/about.xul", "about", "chrome,centerscreen");
}


function reminderFox_processRecentReminders() {
	var changed = false;
	var NUM_OF_DAYS = 6;  // needs to be less than weekly reminder so Completed mark isn't cleared...
												// the real fix is to check if the reminder you are clearing occurs today as well; if so don't clear the mark
	var i, j;

	var reminderEvents = 	reminderFox_getReminderEvents();
	var reminder;

	// set dates to search during the last week only
	var todaysDate = new Date();
	var startDate = new Date();
	var endDateTomorrow = new Date( startDate.getFullYear(), startDate.getMonth(), startDate.getDate() );
	endDateTomorrow.setDate( startDate.getDate() + 1 );
	startDate.setDate(startDate.getDate() - NUM_OF_DAYS );
	
	var removeArray = new Array();
	var removeArrayIndex = 0;

	for (  i = 0; i < reminderEvents.length; i++ ) {
		reminder = reminderEvents[i];
		var allReminders = reminderFox_getAllRemindersInDateRange( reminder,  startDate, endDateTomorrow, true );
		for (  j = 0; j < allReminders.length; j++ ) {
			var recentReminder = allReminders[j];		
			var dateCompare = reminderFox_compareDates( recentReminder.date, todaysDate );	
			// if a reminder is set to Remind Until Complete (and it's already happened) set to today's date to check for alarm		
			if (recentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED && dateCompare == -1 ) {
		 		recentReminder = reminderFox_cloneReminderFoxEvent( recentReminder );	 		
				recentReminder.date  = new Date( todaysDate.getFullYear(), todaysDate.getMonth(), todaysDate.getDate(), 
						 			recentReminder.date.getHours(), recentReminder.date.getMinutes() );			 			 
				dateCompare = 0;		 // set as today's date						
		 	}		
			// if the reminder happened today or tomorrow, we want to check the alert
			if (  dateCompare != -1 ) {
				// only if  a reminder that occurs today or tomorrow ....
				if ( recentReminder.alarm != null ) {
					reminderFox_processAlarm( recentReminder );
				}	
			}
			else {		 
			
			// the reminder happened in the last week
				// if the reminder is a one-time reminder that occurred in the last NUM_OF_DAYS, we'll
				// remove him
				//  MAYBE this should be an option?  
	//			if ( recentReminder.recurrence == REMINDER_RECURRENCE_ONETIME ) {
	//					// mark this reminder for removal
	//					removeArray[removeArrayIndex] = i;
	//					removeArrayIndex++;
	//					changed = true;
	//			}
		
				
				// check for any RemindUntilComplete - if found, set it to be shown in today's list of reminders
				if ( recentReminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED ) {
						reminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED;				
					changed = true;
				}
				
				// if marked as complete, let's remove that mark so it shows up next year (unless it's a one-time - then there will be no
				// reminder next year)
				if ( recentReminder.complete && recentReminder.recurrence  != REMINDER_RECURRENCE_ONETIME ) {
					reminder.complete = false;
					changed = true;
				}
			}
		}
	}
	// now let's remove our reminders
	for ( var k = removeArray.length - 1; k >= 0; k-- ) {
		reminderFox_removeElement( reminderEvents, removeArray[ k ] );		
	}

	
	return changed;
}



function reminderFox_createToolTip(todayRemindersArr) {
	var j;
	var currentNode;
	var todayDescription;
	var upcomingDescription;
	var spacer;
	var todoDescription;
	
	// we'll set the icon depending on if there's current, upcoming, 
	// or no reminders
 	var icon = document.getElementById('reminderFox-statusLabel');
 	icon.setAttribute("status", "noReminders");

 	var upcomingRemindersArr = reminderFox_getUpcomingReminders();
 	var todosArr = reminderFox_getVisibleTodos();

 	// clear old tooltips
	var todayBox = document.getElementById("todaysRemindersBox");
	if ( todayBox != null ) {
	     while (todayBox.hasChildNodes()) {
	    	 todayBox.removeChild(todayBox.firstChild);
	  	 }		
	}
					
	var upcomingBox = document.getElementById("upcomingRemindersBox");
	if ( upcomingBox != null ) {
	     while (upcomingBox.hasChildNodes()) {
	    	 upcomingBox.removeChild(upcomingBox.firstChild);
	  	 }		
	}
	
	var todoBox = document.getElementById("todosBox");
	if ( todoBox != null ) {
	     while (todoBox.hasChildNodes()) {
	    	 todoBox.removeChild(todoBox.firstChild);
	  	 }	
	}
		
	// remove old tooltip box
	var tooltipChildren = document.getElementById("tooltipChildren");
	todoDescription = document.getElementById( "todoDescription" );
	if ( todoDescription != null ) {
		tooltipChildren.removeChild( todoDescription );
	}
	var todosBox = document.getElementById( "todosBox" );
	if ( todosBox != null ) {
		tooltipChildren.removeChild( todosBox );		
	}
	
	// remove old reminders box
	var tooltipChildrenReminders = document.getElementById("tooltipChildrenReminders");

	todayDescription = document.getElementById( "todayRemindersDescription" );
	if ( todayDescription != null ) {
		tooltipChildrenReminders.removeChild( todayDescription );
	}
	
	todayBox = document.getElementById( "todaysRemindersBox" );
	if ( todayBox != null ) {
		tooltipChildrenReminders.removeChild( todayBox );		
	}
	
    spacer = document.getElementById( "reminderSpacer" );
	if ( spacer != null ) {
		tooltipChildrenReminders.removeChild( spacer );		
	}

	upcomingDescription = document.getElementById( "upcomingRemindersDescription" );
	if ( upcomingDescription != null ) {
		tooltipChildrenReminders.removeChild( upcomingDescription );
	}
	
	upcomingBox = document.getElementById( "upcomingRemindersBox" );
	if ( upcomingBox != null ) {
		tooltipChildrenReminders.removeChild( upcomingBox );		
	}	

	var showReminders = true;			
	try {
		showReminders = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
	} catch(e) {
	}			

	var showTooltips = true;			
	try {
		showTooltips = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
	} catch(e) {
	}			
 	
 	var tooltipWrapLength;
 	if ( todosArr.length > 0 && showReminders && showTooltips) {
 		tooltipWrapLength = reminderFox_TOOLTIP_WITH_TODOS_LINE_LENGTH;
 	}
 	else {
 		tooltipWrapLength = reminderFox_TOOLTIP_LINE_LENGTH;
 	}
 	
 	if ( showReminders ) { 
 			todayDescription = document.createElement("description");
			todayDescription.setAttribute("id", "todayRemindersDescription");
			todayDescription.setAttribute("value",reminderFox_getBundle().getString("rf.main.tooltip.todaysReminders.title"));
			todayDescription.setAttribute("style", "font-weight:bold;");
			tooltipChildrenReminders.appendChild(todayDescription);
	
			var todayVbox = document.createElement("vbox");
			todayVbox.setAttribute("id", "todaysRemindersBox");
			tooltipChildrenReminders.appendChild(todayVbox);
 				
			spacer =  	document.createElement("spacer");	
 			spacer.setAttribute("id", "reminderSpacer");		
 			spacer.setAttribute("height", "4px");		
			tooltipChildrenReminders.appendChild(spacer); 			
 		
 	 		upcomingDescription = document.createElement("description");
			upcomingDescription.setAttribute("id", "upcomingRemindersDescription");
			upcomingDescription.setAttribute("value", reminderFox_getBundle().getString("rf.main.tooltip.upcomingReminders.title"));
			upcomingDescription.setAttribute("style", "font-weight:bold;");
			tooltipChildrenReminders.appendChild(upcomingDescription);

			var upcomingVbox = document.createElement("vbox");
			upcomingVbox.setAttribute("id", "upcomingRemindersBox");
			tooltipChildrenReminders.appendChild(upcomingVbox);

	 		reminderFox_populateTodayToolTip(todayRemindersArr, tooltipWrapLength );
	 		reminderFox_populateUpcomingToolTip(upcomingRemindersArr, tooltipWrapLength);
	}
	
	if ( showTooltips && todosArr.length > 0 ) {
		todoDescription = document.createElement("description");
		todoDescription.setAttribute("id", "todoDescription");
		todoDescription.setAttribute("value", reminderFox_getBundle().getString("rf.main.tooltip.todos.title") );
		todoDescription.setAttribute("style", "font-weight:bold;");
		tooltipChildren.appendChild(todoDescription);
		
		var todosVbox = document.createElement("vbox");
		todosVbox.setAttribute("id", "todosBox");
		tooltipChildren.appendChild(todosVbox);
		reminderFox_populateTodoToolTip(todosArr, (tooltipWrapLength - 13));	
	}
 		
	if ( todayRemindersArr.length > 0 ) {
		icon.setAttribute("status", "currentReminder");
	}
	else if ( upcomingRemindersArr.length > 0 ) {
		icon.setAttribute("status", "upcomingReminder");
	}	
}

function reminderFox_populateTodayToolTip(remindersArr, tooltipWrapLength) {
	var lblparent = document.getElementById("todaysRemindersBox");	
	// Get the template from the user preference	
	var template = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TODAYS_REMINDERS_LABEL);
	reminderFox_populateToolTip(remindersArr, tooltipWrapLength, lblparent, template ) ;
}


function reminderFox_populateUpcomingToolTip( remindersArr, tooltipWrapLength) {
	var lblparent = document.getElementById("upcomingRemindersBox");
	// Get the template from the user preference	
	var template = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_UPCOMING_REMINDERS_LABEL);
	reminderFox_populateToolTip(remindersArr, tooltipWrapLength, lblparent, template ) ;
}

function reminderFox_populateToolTip(remindersArr, tooltipWrapLength, lblparent, template )  {
	var j;
	var remLabel;
	if (remindersArr.length > 0 ) {
		var lineWrappedIndent = 5;	
		for(var i=0; i < remindersArr.length; i++) {		
			var startIndex = 0;
			var remainingString = reminderFox_populateReminderLabel(remindersArr[i], template);	
			var afterFirst = false;
			while ( remainingString.length > tooltipWrapLength  ) {				
				// go back to last whitespace
				var lastIndex = remainingString.lastIndexOf( ' ', tooltipWrapLength );
				var forceLineBreak = false;
				if ( lastIndex == -1 ) {
					forceLineBreak = true;
			    	lastIndex = tooltipWrapLength + 1;
				}
				if ( lastIndex != -1 ) {
				    var curStr = remainingString.substring( 0, lastIndex );
				    // after the first line, for any extra lines we will indent some.This makes
				    // the entry look nice when wrapping to the following lines
				    if ( afterFirst )  {
				    	j = 0;
				    	while ( j < lineWrappedIndent ) {
				    		curStr = " " + curStr;
				    		j++;
				    	}
				    }	
				    	    
				    remLabel = document.createElement("description");
					remLabel.setAttribute("value", curStr);
					if ( remindersArr[i].priority == REMINDER_PRIORITY_IMPORTANT) { 
						remLabel.setAttribute("style", "color: red;");
					}
					else {
						remLabel.removeAttribute( "style" );
					}
					lblparent.appendChild(remLabel);
					afterFirst = true;
				}
				
				if ( forceLineBreak ) {
					startIndex = lastIndex;
				}
				else {
					startIndex = lastIndex + 1;
				}
				remainingString = remainingString.substring( startIndex );		  										
			}
			if ( afterFirst )  {
			   	j = 0;
			   	while ( j < lineWrappedIndent ) {
			   		remainingString = " " + remainingString;
			   		j++;
			   	}
			}						
			reminderFox_addItemToTooltip( remindersArr[i], true, remainingString, lblparent );
		}
	} else {
		var noneLabel = document.createElement("description");
		noneLabel.setAttribute("value",reminderFox_getBundle().getString( "rf.main.tooltip.reminders.none" ) );  
		lblparent.appendChild(noneLabel);
	}
}

function reminderFox_addItemToTooltip( reminderOrTodo, isReminder, labelText, parentElement ) {
	var hasNotes = reminderOrTodo.notes != null && reminderOrTodo.notes != "";
	var isRUC = false;
	if ( isReminder ) {
		isRUC = reminderOrTodo.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED;
	}
	if ( !hasNotes && !isRUC ) {   // no image needed
			var remLabel = document.createElement("description");
			remLabel.setAttribute("value", labelText);
			if ( reminderOrTodo.priority == REMINDER_PRIORITY_IMPORTANT) { 
				remLabel.setAttribute("style", "color: red;");
			}
			else {
				remLabel.removeAttribute( "style" );
			}
			parentElement.appendChild(remLabel);
	}
	else {
			// create image box
			var hbox = document.createElement("hbox");			
			var remLabel = document.createElement("description");
			
			var vbox = document.createElement("vbox");	
			var spacer = 	document.createElement("spacer");	
			spacer.setAttribute("flex", "1" )	
			vbox.appendChild( spacer );
			
			if ( ! (isRUC && hasNotes) ) {
				// if only 1 image  (remindUntilCompleted / notes )
				if ( hasNotes ) {
					var image1 = document.createElement("image");
					image1.setAttribute("src", REMINDER_FOX_NOTES_IMAGE );
					vbox.appendChild( image1 );
				}
				else {
					var image1 = document.createElement("image");
					image1.setAttribute("src", REMINDER_FOX_REMIND_UNTIL_COMPLETED_IMAGE );
					vbox.appendChild( image1 );
				}
			}
			else {				
				// if multi image
				var imagehbox = document.createElement("hbox");			
				var image1 = document.createElement("image");
				image1.setAttribute("src", REMINDER_FOX_NOTES_IMAGE );
				imagehbox.appendChild( image1 );		
							
				var image2 = document.createElement("image");
				image2.setAttribute("src", REMINDER_FOX_REMIND_UNTIL_COMPLETED_IMAGE );
				imagehbox.appendChild( image2 );
				
				vbox.appendChild(imagehbox );
			}
			
			
			// end multi
			vbox.appendChild( spacer );

			remLabel.setAttribute("value", labelText);

			if ( reminderOrTodo.priority == REMINDER_PRIORITY_IMPORTANT) { 
				remLabel.setAttribute("style", "color: red;");
			}
			else {
				remLabel.removeAttribute( "style" );
			}
			hbox.appendChild( remLabel );
			hbox.appendChild( vbox );
			
			parentElement.appendChild(hbox);
	}
}


function reminderFox_populateTodoToolTip( todosArr, tooltipWrapLength) {
	var j;
	var remLabel;
	var todosBox = document.getElementById("todosBox");
	
	if (todosArr.length > 0 ) {
		for(var i=0; i < todosArr.length; i++) {	
			var remainingString = todosArr[i].summary;
		
			var lineWrappedIndent = 5;
			
			var startIndex = 0;
			var afterFirst = false;
			while ( remainingString.length > tooltipWrapLength ) {				
				// go back to last whitespace
				var lastIndex = remainingString.lastIndexOf( ' ', tooltipWrapLength );
				var forceLineBreak = false;
				if ( lastIndex == -1 ) {
					forceLineBreak = true;
			    	lastIndex = tooltipWrapLength + 1;
				}					
				if ( lastIndex != -1 ) {
				    var curStr = remainingString.substring( 0, lastIndex );
				    // after the first line, for any extra lines we will indent some.  This makes
				    // the entry look nice when wrapping to the following lines
				    if ( afterFirst )  {
				    	j = 0;
				    	while ( j < lineWrappedIndent ) {
				    		curStr = " " + curStr;
				    		j++;
				    	}
				    }				    
				    
				    remLabel = document.createElement("description");
					remLabel.setAttribute("value", curStr);
					if ( todosArr[i].priority == REMINDER_PRIORITY_IMPORTANT ) {
						remLabel.setAttribute("style", "color: red;");
					}
					else {
					remLabel.removeAttribute( "style" );
					}
					todosBox.appendChild(remLabel);
					afterFirst = true;
				}
								
				if ( forceLineBreak ) {
					startIndex = lastIndex;
				}
				else {
					startIndex = lastIndex + 1;
				}
				remainingString = remainingString.substring( startIndex );				    										
			}
			if ( afterFirst )  {
			   	j = 0;
			   	while ( j < lineWrappedIndent ) {
			   		remainingString = " " + remainingString;
			   		j++;
			   	}
			}
			reminderFox_addItemToTooltip( todosArr[i], false, remainingString, todosBox );
		}
	} else {
		var noneLabel = document.createElement("description");
		noneLabel.setAttribute("value", reminderFox_getBundle().getString( "rf.main.tooltip.reminders.none" ) );  
		todosBox.appendChild(noneLabel);
	}
}

function reminderFox_getUpcomingReminders() {
	var i, j;
	var reminder;  

	var reminderEvents = 	reminderFox_getReminderEvents();
	var upcomingReminders = new Array();

	var upcomingReminderDays =reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF);
	if ( upcomingReminderDays > 364 ) {
		upcomingReminderDays = 364;
	}

	var currentDate = new Date();
	var endDate  = new Date( currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate() );
	endDate.setDate( endDate.getDate() + upcomingReminderDays );
	currentDate.setDate( currentDate.getDate() + 1 );  // want dates starting with tomorrow
	for( i = 0; i < reminderEvents.length; i++) {
		var todayReminder = null;
		reminder = reminderEvents[i];
		// for performance reasons, sort all the yearly items first, which should generally be in order
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY || 
				reminder.recurrence  == REMINDER_RECURRENCE_ONETIME ) {
			var allReminders = reminderFox_getAllRemindersInDateRange( reminder,  currentDate, endDate, true );
			for (  j = 0; j < allReminders.length; j++ ) {
				var upcomingReminder = allReminders[j];
				if ( upcomingReminder.complete && j == 0 ) {
					continue;  //ignore first complete
				}
				upcomingReminder  = reminderFox_processReminderDescription(upcomingReminder, upcomingReminder.date.getFullYear());			
					
				var index = reminderFox_getSortNewUpcomingReminderIndex( upcomingReminders, upcomingReminder );	
				reminderFox_insertIntoArray( upcomingReminders, upcomingReminder, index );
			}
		}
	}
	
	// now sort repeating items...
	for( i = 0; i < reminderEvents.length; i++) {
		var todayReminder = null;
		reminder = reminderEvents[i];
		if ( reminder.recurrence  != REMINDER_RECURRENCE_YEARLY &&
				reminder.recurrence  != REMINDER_RECURRENCE_ONETIME ) {
			var allReminders = reminderFox_getAllRemindersInDateRange( reminder,  currentDate, endDate, true );
			for (  j = 0; j < allReminders.length; j++ ) {
				var upcomingReminder = allReminders[j];
				if ( upcomingReminder.complete && j == 0 ) {
					continue;  //ignore first complete
				}
				upcomingReminder  = reminderFox_processReminderDescription(upcomingReminder, upcomingReminder.date.getFullYear());			
					
				var index = reminderFox_getSortNewUpcomingReminderIndex( upcomingReminders, upcomingReminder );	
				reminderFox_insertIntoArray( upcomingReminders, upcomingReminder, index );
			}
		}
	}

	return upcomingReminders;
}


function reminderFox_getTodaysReminders(  ) {
	var i; 
	var reminder;

	var reminderEvents = 	reminderFox_getReminderEvents();
	var todaysReminders = new Array();

	// get reminders for today's date only
	var currentDate = new Date();
	var endDate  = currentDate;

	for( i = 0; i < reminderEvents.length; i++) {
		var todayReminder = null;
		reminder = reminderEvents[i];
		
		// if it's marked as RemindUntilComplete, this should be treated as Today's date
	 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
	 		reminder = reminderFox_cloneReminderFoxEvent( reminder );	 		
			reminder.date  = new Date( currentDate.getFullYear(), currentDate.getMonth(), currentDate.getDate(), 
					 			reminder.date.getHours(), reminder.date.getMinutes() );			
			todayReminder = reminder;	 							 								
	 	}		
	 	else {
			var newReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, currentDate );		
			if (newReminder != null &&  reminderFox_compareDates(  newReminder.date, endDate ) == 0 ) {
				newReminder = reminderFox_cloneReminderFoxEvent( newReminder );
				todayReminder = newReminder;					
			}
		}
		
		if ( todayReminder != null && !todayReminder.complete ) {		
			todayReminder  = reminderFox_processReminderDescription(todayReminder, todayReminder.date.getFullYear());				
			reminderFox_insertIntoArray( todaysReminders, todayReminder, todaysReminders.length );
		}
	}	
	
	return todaysReminders;
}

function reminderFox_getVisibleTodos() {
	var todos = reminderFox_getReminderTodos();
	var visibleTodosArray = new Array();
	var	visibleTodosArrayIndex = 0;
	for(var  i = 0; i < todos.length; i++) {
		 if ( !todos[i].showInTooltip || todos[i].complete ) {
				continue;
		}			
		visibleTodosArray[visibleTodosArrayIndex] = todos[i];
		visibleTodosArrayIndex++;	
	}
	return visibleTodosArray;
}


function reminderFox_storeTimeOfLastUpdate() {
	// output the last time of update for debugging, but only if the
	// preference already exists
	try {		
		reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_UPDATE);

		var currentDate = new Date();
		var hours = currentDate.getHours();
		var mins = currentDate.getMinutes();
		var secs = currentDate.getSeconds();
		
		var readableMins = mins;
		if ( mins < 10 ) {
			readableMins = "0" + readableMins;
		}
		var readableSecs = secs;
		if ( secs < 10 ) {
			readableSecs = "0" + readableSecs;
		}
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_UPDATE, hours + ":" + readableMins + ":" + readableSecs);	
	} catch(e) {
		// pref doesn't exist.  Do nothing.
	}	
}


function reminderFox_moveBox() { 
    //check if box is ind the right location
    var toolbar = document.getElementById(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR));
    var box = document.getElementById("reminderFox-statusLabel");

    var position;
    try {
    	position = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION) ;
    }
    catch( e ) {
    	position = -1;
    }

    //if toolbar doesn't exist move to default location
    if (!toolbar) {
    	reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, REMINDER_FOX_TOOLBAR_DEFAULT);
		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, REMINDER_FOX_TOOLBAR_POSITION_DEFAULT);      
     	return;
    }

    // bail if it is in the right place
    if (reminderFox_indexOf(toolbar,box, false) == position) {
	     return;
     }

    //remove us from parent
    box.parentNode.removeChild(box);

    reminderFox_insertAtIndex(toolbar, box, position);
  }
  

 function reminderFox_insertAtIndex(aParent, aChild, aIndex)  {
    var children = aParent.childNodes;
    if ((children.length == 0) || (aIndex >= children.length) || (aIndex < 0)) {
      aParent.appendChild(aChild);
     }
    else {
       aParent.insertBefore(aChild, children[aIndex]);
     }
  }

function reminderFox_storeTimeOfLastAlert() {
	// output the last time of update for debugging, but only if the
	// preference already exists
	try {		
		var currentDate = new Date();		
		var time = currentDate.getTime();
		reminderFox_prefsBranch.setCharPref( REMINDER_FOX_LAST_ALERT, time);			
	} catch(e) {
		// pref doesn't exist.  Do nothing.
	}	
}

function reminderFox_storeTimeOfLastProcessed() {
	// output the last time of update for debugging, but only if the
	// preference already exists
	try {		
		var currentDate = new Date();		
		var time = currentDate.getTime();
		reminderFox_prefsBranch.setCharPref( REMINDER_FOX_LAST_PROCESSED, time);			
	} catch(e) {
		// pref doesn't exist.  Do nothing.
	}	
}





// this runs every hour and updates all of the windows with the latest reminders
function reminderFox_initializeReminderFox(clearReminders) {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator =  reminderFox_getWindowEnumerator();

	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		// if this is the very first (oldest) window opened, then let's process the reminders
		if ( window == oldestWindow ) {
			// verify that the correct amount of time has elapsed since last update.   Sometimes due to 
			// what appears to be a FireFox bug, sometimes a large number of  timeouts are called.  This
			// ensures that we only process once after the proper amount of time
			var lastTime = 		reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_LAST_PROCESSED);
			var currentDate = new Date();
			var currentTime = currentDate.getTime();
			var lastTimeElapsed = null;
			if ( lastTime != null && lastTime != "" )  {
				lastTimeElapsed = parseInt(lastTime) + reminderFox_HOUR_TIMEOUT;
			}
			reminderFox_logMessageLevel(currentDate + "check - should Initialize: " + (lastTime == null  || lastTime == "" ||  (currentTime+50) >= lastTimeElapsed ) +  " ==  lastTime " + lastTime + " -- currentTime: " + currentTime + " -- lastTimeElapsed: " + lastTimeElapsed , REMINDER_FOX_LOG_LEVEL_FINE);

			if (lastTime == null  || lastTime == "" ||  (currentTime+100) >= lastTimeElapsed ) {
				var updateWindows = false;
				var fileChanged = reminderFox_timeStampHasChanged();
				if ( fileChanged ) {
					reminderFox_storeTimeStamp();
					updateWindows = true;
				}		

				var changed = false;
				try { 
					changed = reminderFox_processRecentReminders();
				}
				catch ( e ) {
				}
				if ( changed ) {
					updateWindows = true;
					// write stuff out
					reminderFox_writeOutRemindersAndTodos();					
				}
				
				var currentDate = new Date();
				var day = currentDate.getDate();
				if ( reminderFox_lastDay  != day ) {
					updateWindows = true;
				}
				reminderFox_logMessageLevel("Initialize: " + currentDate + " --Update?: " + updateWindows +" -- fileChanged: " + fileChanged + ",  changed: " + changed + ", dayChanged: " + (reminderFox_lastDay != day), REMINDER_FOX_LOG_LEVEL_INFO);
				if ( updateWindows ) {
					oldestWindow.reminderFox_updateRemindersInWindow();	
					if ( clearReminders ) {
						// clear reminders from memory
						reminderFox_clearRemindersAndTodos();
					}	
					while (windowEnumerator.hasMoreElements()) {
						var currentWindow = windowEnumerator.getNext();		
						currentWindow.reminderFox_updateRemindersInWindow();		
						if ( clearReminders ) {
							// clear reminders from memory
							currentWindow.reminderFox_clearRemindersAndTodos();
						}							
					}
				}

				
				if ( clearReminders ) {
					// clear reminders from memory
					reminderFox_clearRemindersAndTodos();
				}			
				reminderFox_lastDay  = day;	
				reminderFox_storeTimeOfLastProcessed();
				reminderFox_logMessageLevel(currentDate + "Setting Hourly timeout!", REMINDER_FOX_LOG_LEVEL_FINE);
				
				window.setTimeout(reminderFox_initializeReminderFoxHourly, reminderFox_HOUR_TIMEOUT);  // 10000 == 10 sec min
			}		
		}
	}
}

// this runs every hour and updates all of the windows with the latest reminders
function reminderFox_initializeReminderFoxHourly() {
	reminderFox_initializeReminderFox(true);
}

function reminderFox_updateRemindersInWindow() {
	reminderFox_logMessageLevel("Updating reminders in window: " + new Date(), REMINDER_FOX_LOG_LEVEL_INFO);	 
	var text = document.getElementById('reminderFox-statusLabel');
	if (text != null) {
		var reminderString = "";
		var remindersArray =reminderFox_getTodaysReminders();
		var important = false;
		for ( var i = 0; i < remindersArray.length; i++ ) {
			reminderString = reminderString + remindersArray[i].summary;
			if ( i < remindersArray.length - 1 ) {  
				reminderString = reminderString + ", ";
			}				
			if ( remindersArray[i].priority == REMINDER_PRIORITY_IMPORTANT ) {
				important = true;
			}
		}
		if (reminderString != "") { 
			// don't want text on status bar too long; truncate it after it gets big
			if ( reminderString.length > reminderFox_STATUS_TEXT_MAX_LENGTH ) {
				reminderString = reminderString.substring( 0, reminderFox_STATUS_TEXT_MAX_LENGTH ) + "...";
			}					

			if ( important ) {
				text.setAttribute("style", "color: red;");
			}
			else{
				text.removeAttribute( "style" );
			}

			var showStatusText = true;
			try {
				showStatusText = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
			} catch(e) {
			}

			if ( showStatusText ) {
				text.setAttribute("class", "statusbarpanel-iconic-text");
				text.setAttribute("label", reminderString);					
			}
			else {
				// user doesn't want the reminder text - just use icon
				text.setAttribute("class", "statusbarpanel-iconic");
			}					
		} else {
			text.setAttribute("class", "statusbarpanel-iconic");
		}

		reminderFox_createToolTip(remindersArray);		
	}
}


function reminderFox_activateOptionsContext(event) {	
	// dynamically handle the Show Alerts menu item 
	var alertType;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
		alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	}
			
	var showAlert = document.getElementById("options-contextmenu-showAlert");	
	
	// if the user has set it to no alerts, the option should be disabled
	if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
		showAlert.setAttribute("disabled", "true");
		showAlert.setAttribute("checked", "false");	    
	}
	// if alerts are suspended, the option is unchecked
	else if ( alertType.indexOf( REMINDER_FOX_SUSPEND_ALERT_PREF ) != -1 ) {
		showAlert.setAttribute("disabled", "false");
		showAlert.setAttribute("checked", "false");
		
	}
	// otherwise, in normal case the option is checked
	else {
		showAlert.setAttribute("disabled", "false");
		showAlert.setAttribute("checked", "true");
	}	

	var reminderFoxStatusbarPanel = document.getElementById("reminderFox-statusLabel");
	var optionsContextMenu = document.getElementById("options-contextmenu");
	var xCoord = event.clientX;
	var yCoord = event.clientY;
	document.popupNode = reminderFoxStatusbarPanel;
	optionsContextMenu.showPopup(reminderFoxStatusbarPanel, xCoord, yCoord, "bottomleft", "topleft");
}

function reminderFox_toggleShowAlert() {
	var alertType;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
		alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	}
	
	// if it's marked as suspended, change to original value
	var suspendedIndex = alertType.indexOf( REMINDER_FOX_SUSPEND_ALERT_PREF ) ;		
	if ( suspendedIndex != -1 ) {
		alertType = alertType.substring( suspendedIndex + REMINDER_FOX_SUSPEND_ALERT_PREF.length );
	}
	// otherwise, suspend the alert
	else {
		alertType = REMINDER_FOX_SUSPEND_ALERT_PREF + alertType;
	}
	
	reminderFox_prefsBranch.setCharPref( REMINDER_FOX_ENABLE_ALERT_PREF, alertType);
}

function processKeyPressedOnReminderTree(event) {
	if (event.keyCode == 46)
		removeReminder();
}

function reminderFox_showAlertSlider() {
	var i;
	var remindersArray;
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator =  reminderFox_getWindowEnumerator();

	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		// Only show the alert  for the oldest window (the first browser you opened).  
		// We don't want each new window to have its own timeout to respond to, because we only
		// need to show one alert for all browser windows
		if ( window == oldestWindow ) {
			// Reshow alert after ALERT_TIMEOUT minutes.  -- (note: options dialog - needs to clear out lastAlert pref when changed)
			var alert_timeout = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);

			if ( alert_timeout > 0 ) {
				// convert from minutes to milliseconds	
				alert_timeout = alert_timeout * 60000; 
				
				// verify that the correct amount of time has elapsed since last alert slider.   Sometimes due to 
				// what appears to be a FireFox bug, sometimes a large number of alert timeouts are called.  This
				// ensures that only the correct one will display the alert slider after the proper amount of time
				var lastTime = 	reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_LAST_ALERT);
				
				var lastTimeElapsed = null;
				if ( lastTime != null && lastTime != "" )  {
					lastTimeElapsed = parseInt(lastTime) + alert_timeout;
				}
				var currentDate = new Date();
				var currentTime =currentDate.getTime();
				if (lastTime == null ||  (currentTime+100) >= lastTimeElapsed ) {  // +100 as small buffer (sometimes times are slightly off)
					var alerts = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
					var alertType;
					try {
						alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
					} catch(e) {
						alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
					}
					
					if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
					    return;
					}
					ensureRemindersSynchronized();

					// check for empty today/upcoming - if both empty then ignore - check if today equals none string; if so, then check if upcoming == none string 
					var lblparent = document.getElementById("todaysRemindersBox");	
					var lblparent2 = document.getElementById("upcomingRemindersBox");	
			
				    var children = null;
				    var children2 = null;
				    var todayPref = false;
				    var upcomingPref = false;
				    if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_TODAY || alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {
						children = lblparent.childNodes;
						todayPref = true;
					}						
					if ( alertType ==REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING || alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {
						children2 = lblparent2.childNodes;
						upcomingPref = true;
					}	
					var noToday = ( children == null || (  children.length == 1 && children[0].getAttribute( "value" ) == reminderFox_getBundle().getString( "rf.main.tooltip.reminders.none" )  ) );
					var noUpcoming =  ( children2 == null || (  children2.length == 1 && children2[0].getAttribute( "value" ) == reminderFox_getBundle().getString( "rf.main.tooltip.reminders.none" )  ) );
					var ignoreAlert = noToday && noUpcoming;
	 				if ( !ignoreAlert  ) {	
	 					if ( !todayPref ) {
	 						lblparent = null;
	 					}
	 					if ( !upcomingPref ) {
	 						lblparent2 = null;
	 					}
		   				var newOptions = { todaysreminders: lblparent, upcomingreminders: lblparent2,  alertTypeToShow: alertType };	 					
	 					window.openDialog("chrome://reminderfox/content/alerts/reminderalert.xul",			"alert:alert", "chrome,dialog=yes,titlebar=no,popup=yes", newOptions );
					}
					reminderFox_clearRemindersAndTodos();				
					reminderFox_logMessageLevel("AlertSlider: " + currentDate, REMINDER_FOX_LOG_LEVEL_INFO);
					reminderFox_storeTimeOfLastAlert();  
					window.setTimeout(reminderFox_showAlertSlider, alert_timeout);
				}
			}					
		}
	}
}



function reminderFox_start() {
	reminderFox_loadDefaultPreferences();

	reminderFox_moveBox();

	// if this is the very first window opened, then let's set the timeout on it.
	reminderFox_initializeReminderFox(false);

	// Show the alert slider when the reminders are first initialized.
	// Only show if this is the oldest window (the first browser you opened).  That is, 
	// if you open a new window, we do not need to show the alert again.  
	reminderFox_showAlertSlider();

	// Initialize reminder fox for the browser window
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator =  reminderFox_getWindowEnumerator();
	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		if ( window != oldestWindow ) {
			//  it's just a new window, we'll load it (tooltips, status bar)
			reminderFox_updateRemindersInWindow();	
		}
	}

	// clear reminders from memory
	reminderFox_clearRemindersAndTodos();
}

function reminderFox_getTimeString( reminder ) {
	var timeString = null;
	if ( !reminder.allDayEvent ) {
		try {
			var hours = reminder.date.getHours();
			var AMorPM =reminderFox_getBundle().getString("rf.add.time.PM");
			if ( AMorPM != "" ) {
				if ( hours < 12 ) {
					AMorPM = reminderFox_getBundle().getString("rf.add.time.AM");
				}
				if ( hours == 0 ) {
					hours = 12;
				}
				if ( hours >= 13 ) {
					hours = hours -12;
				}	
			}			

			var minutes = reminder.date.getMinutes();
			if ( minutes < 10 ) {
				minutes = "0" + minutes;
			}
							
			timeString = hours + reminderFox_getBundle().getString("rf.add.time.delimiter") + minutes;
			if ( AMorPM != "" ) {
				timeString = timeString + " " + AMorPM;		
			}
		}
		catch ( e ) { 
		}
	}	
	return timeString;
}

function reminderFox_populateReminderLabel( reminder , template) {
	var reminderLabel = template;

	// Replace the [variables]	
	var startBracketIndex =reminderLabel.indexOf("[");
	while (startBracketIndex != -1) {
		var endBracketIndex = reminderLabel.indexOf("]", startBracketIndex);
		if (endBracketIndex != -1) {
			// Check for a fishy [
			if (endBracketIndex - startBracketIndex < 3) {
				startBracketIndex = reminderLabel.indexOf("[", ++startBracketIndex);
			}
			else {
				var variable = reminderLabel.substring(startBracketIndex + 1, endBracketIndex);				
				var decodedVariable = reminderFox_decodeReminderLabelVariable(reminder, variable);
				var decodedVariableLength = decodedVariable.length;
				var startTrim = startBracketIndex;
				var endTrim = endBracketIndex;
				if ( variable == "time" && decodedVariableLength == 0 ) {
					// trim the ( ) from around time if the time is empty (all-day event)
					if ( reminderLabel.charAt( startBracketIndex - 1 ) == "(" &&
						reminderLabel.charAt( endBracketIndex + 1 ) == ")"  ) {
						startTrim = startTrim - 1;
						endTrim = endTrim + 1;
					}
				}
				reminderLabel = reminderLabel.substring(0, startTrim) + decodedVariable + reminderLabel.substring(endTrim + 1, reminderLabel.length);
				startBracketIndex = reminderLabel.indexOf("[", startBracketIndex + decodedVariableLength);
			}
		}
	}
	return reminderLabel;
}

function reminderFox_getDaysUntilDate( targetDate ) {
	var currentDate = new Date();
	var date = new Date( targetDate.getFullYear(), targetDate.getMonth(), targetDate.getDate() );	
	date.setHours( 0, 0, 0 );
	currentDate.setHours( 0, 0, 0 );
	
    // The number of milliseconds in one day
    var ONE_DAY = 1000 * 60 * 60 * 24

    // Convert both dates to milliseconds
    var date1_ms = date.getTime()
    var date2_ms = currentDate.getTime()

    // Calculate the difference in milliseconds
    var difference_ms = Math.abs(date1_ms - date2_ms)
    
    // Convert back to days and return
    return Math.round(difference_ms/ONE_DAY)
}

function reminderFox_decodeReminderLabelVariable(reminder, variable) {
	var decodedVariable = "";
	switch (variable) {
		case "reminderDesc":
			decodedVariable = reminder.summary;
        	break;
      	case "longDay":
      		decodedVariable = reminderFox_integerToLongDay(reminder.date.getDay());
        	break;
		case "shortDay":
			decodedVariable = reminderFox_integerToShortDay(reminder.date.getDay());
        	break;            
		case "longMonth":
			decodedVariable = reminderFox_integerToLongMonth(reminder.date.getMonth());
        	break;
		case "shortMonth":
			decodedVariable = reminderFox_integerToShortMonth(reminder.date.getMonth());
        	break;
		case "numMonth":
			decodedVariable = (reminder.date.getMonth() + 1) + "";
        	break;
		case "date":
			decodedVariable = reminder.date.getDate() + "";
        	break;            
		case "longYear":
			decodedVariable = reminder.date.getFullYear() + "";
        	break;
		case "shortYear":
			var fullYear = reminder.date.getFullYear() + "";
			decodedVariable = fullYear.substring(2);
        	break;
		case "time":
			if (reminder.allDayEvent)
				decodedVariable = "";
			else
				decodedVariable = reminderFox_getTimeString(reminder);
        	break;            
		case "daysUntil":
			decodedVariable = reminderFox_getDaysUntilDate( reminder.date );
        	break;
        default:
        	decodedVariable = "[" + variable + "]";
        	break;
    } 
    return decodedVariable;
}

function reminderFox_integerToShortDay( dayOfWeek) {
	var shortDay = "";
	switch (dayOfWeek) {
		case 0:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.0.name.Mmm");
        	break;
      	case 1:
      		shortDay = reminderFox_getBundle().getString("rf.options.day.1.name.Mmm");
        	break;
		case 2:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.2.name.Mmm");
        	break;            
		case 3:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.3.name.Mmm");
        	break;
		case 4:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.4.name.Mmm");
        	break;
		case 5:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.5.name.Mmm");
        	break;
		case 6:
			shortDay =  reminderFox_getBundle().getString("rf.options.day.6.name.Mmm");
        	break;            
    } 
    return shortDay;
}

function reminderFox_integerToLongDay( dayOfWeek) {
	var longDay = "";
	switch (dayOfWeek) {
		case 0:
			longDay =  reminderFox_getBundle().getString("rf.options.day.0.name");
        	break;
      	case 1:
      		longDay =  reminderFox_getBundle().getString("rf.options.day.1.name");
        	break;
		case 2:
			longDay =  reminderFox_getBundle().getString("rf.options.day.2.name");
        	break;            
		case 3:
			longDay =  reminderFox_getBundle().getString("rf.options.day.3.name");
        	break;
		case 4:
			longDay =  reminderFox_getBundle().getString("rf.options.day.4.name");
        	break;
		case 5:
			longDay =  reminderFox_getBundle().getString("rf.options.day.5.name");
        	break;
		case 6:
			longDay =  reminderFox_getBundle().getString("rf.options.day.6.name");
        	break;            
    } 
    return longDay;
}

function reminderFox_integerToLongMonth( monthOfYear ) {
	var longMonth = "";
	switch (monthOfYear) {
		case 0:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.0.name");
        	break;
      	case 1:
      		longMonth = reminderFox_getBundle().getString("rf.options.month.1.name");
        	break;
		case 2:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.2.name");
        	break;            
		case 3:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.3.name");
        	break;
		case 4:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.4.name");
        	break;
		case 5:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.5.name");
        	break;
		case 6:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.6.name");
        	break;
      	case 7:
      		longMonth =  reminderFox_getBundle().getString("rf.options.month.7.name");
        	break;
		case 8:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.8.name");
        	break;            
		case 9:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.9.name");
        	break;
		case 10:
			longMonth =  reminderFox_getBundle().getString("rf.options.month.10.name");
        	break;
		case 11:
			longMonth = reminderFox_getBundle().getString("rf.options.month.11.name");
        	break;          
    } 
    return longMonth;
}

function reminderFox_integerToShortMonth( monthOfYear ) {
	var shortMonth = "";
	switch (monthOfYear) {
		case 0:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.0.Mmm");
        	break;
      	case 1:
      		shortMonth = reminderFox_getBundle().getString("rf.options.month.1.Mmm");
        	break;
		case 2:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.2.Mmm");
        	break;            
		case 3:
			shortMonth = reminderFox_getBundle().getString("rf.options.month.3.Mmm");
        	break;
		case 4:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.4.Mmm");
        	break;
		case 5:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.5.Mmm");
        	break;
		case 6:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.6.Mmm");
        	break;
		case 7:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.7.Mmm");
        	break;
      	case 8:
      		shortMonth = reminderFox_getBundle().getString("rf.options.month.8.Mmm");
        	break;
		case 9:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.9.Mmm");
        	break;            
		case 10:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.10.Mmm");
        	break;
		case 11:
			shortMonth =  reminderFox_getBundle().getString("rf.options.month.11.Mmm");
        	break;         
    } 
    return shortMonth;
}